#-------------------------------------------------------------------#
# ManageQuiz.pm                                                     #
#-------------------------------------------------------------------#
# Quiz for YaBB 2.6.0                                               #
# Version 0.7.4 beta                                                #
#-------------------------------------------------------------------#
$managequizpmver = 'YaBB 2.6.0 $Revision: 0.7.4 $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage('Quiz');

if (!-e("$vardir/quiz2.txt"))  {
    fopen(FILE, ">>$vardir/quiz2.txt");
    print {FILE} "\$QuizHighScoreLength = 5;\n\$QuizzesPerPage = 10;\n\$QuizMinQuestions = 10;\n\$QuizAddGroups = '';\n\$QuizModGroups = '';\n\$QuizDelGroups = '';\n\$QuizAddAllMembers = 1;\n\$QuizModifyAllMembers = 1;\n\$QuizDeleteAllMembers = 1;\n\$QuizSetTimelimit = 1;\n\$QuizMaxTimelimit = 120;\n\$QuizMaxQuestChars = 500;\n\$QuizMaxDecrpChars = 500;\n\$QuizGuestTab = 1;\n\n1;";
    fclose(FILE);
}

sub quizsettings {
    require "$vardir/quiz2.txt";

    if (!$iamadmin) {
        fatal_error($error_txt{'no_access'});
    }

    my($QuizSetTimelimitChk, $QuizGuestTabChk);

    if ($QuizSetTimelimit) { $QuizSetTimelimitChk = 'checked="checked"'; }
    if ($QuizGuestTab) { $QuizGuestTabChk = 'checked="checked"'; }

    if(!$FORM{'QuizMaxTimelimit'}) { $FORM{'QuizMaxTimelimit'} = 0; }
    if(!$FORM{'QuizGuestTab'}) { $FORM{'QuizGuestTab'} = 0; }

    if(!$FORM{'QuizMaxQuestChars'}) { $FORM{'QuizMaxQuestChars'} = 500; }
    if(!$FORM{'QuizMaxDecrpChars'}) { $FORM{'QuizMaxDecrpChars'} = 500; }

    $k = 2;
    my $box = q{};
    for ('Global Moderator', 'Mid Moderator') {
        ($title, $stars, $starpic, $color) = split/[|]/xsm, $Group{$_};
        $box .= q~<option value="$_"~;

        @b = split /\, /sm, $QuizAddGroups;
        foreach my $line (@b) {
            if ($line eq $title) {
                $box .= q~ selected="selected"~;
            }
        }
        $box .= qq~>$title</option>\n~;
    }
    for (@nopostorder) {
        @groupinfo = split /[|]/xsm, $NoPost{$_};
        $box .= qq~<option value="$_"~;
        @a = split /\, /sm, $QuizAddGroups;
        for my $line (@a) {
            ($lineinfo, undef) = split /[|]/xsm, $NoPost{$line};
            if ($lineinfo eq $groupinfo[0]) {
                $box .= q~ selected="selected"~;
            }
        }
        $box .= qq~>$groupinfo[0]</option>\n~;
        $k++;
    }
    if ($k > 5) { $k = 5; }

    my $modbox = q{};
    for ('Global Moderator', 'Mid Moderator') {
        ($title, $stars, $starpic, $color) = split/[|]/xsm, $Group{$_};
        $modbox .= q~<option value="$_"~;

        @b = split /\, /sm, $QuizModGroups;
        foreach my $line (@b) {
            if ($line eq $title) {
                $modbox .= q~ selected="selected"~;
            }
        }
        $modbox .= qq~>$title</option>\n~;
    }

    $modbox .= qq~>$title</option>~;
    for (@nopostorder) {
        @groupinfo = split /[|]/xsm, $NoPost{$_};
        $modbox .= qq~<option value="$_"~;
        @a = split /\, /sm, $QuizModGroups;
        foreach my $line (@a) {
            ($lineinfo, undef) = split /[|]/xsm, $NoPost{$line};
            if ($lineinfo eq $groupinfo[0]) {
                $modbox .= q~ selected="selected"~;
            }
        }
        $modbox .= qq~>$groupinfo[0]</option>~;
    }

    my $delbox = q{};
    for ('Global Moderator', 'Mid Moderator') {
        ($title, $stars, $starpic, $color) = split/[|]/xsm, $Group{$_};
        $delbox .= q~<option value="$_"~;

        @b = split /\, /sm, $QuizDelGroups;
        foreach my $line (@b) {
            if ($line eq $title) {
                $delbox .= q~ selected="selected"~;
            }
        }
        $delbox .= qq~>$title</option>\n~;
    }

    $delbox .= qq~>$title</option>~;
    for (@nopostorder) {
        @groupinfo = split /[|]/xsm, $NoPost{$_};
        $delbox .= qq~<option value="$_"~;
        @a = split /\, /sm, $QuizDelGroups;
        foreach my $line (@a) {
            ($lineinfo, undef) = split /[|]/xsm, $NoPost{$line};
            if ($lineinfo eq $groupinfo[0]) {
                $delbox .= q~ selected="selected"~;
            }
        }
        $delbox .= qq~>$groupinfo[0]</option>~;
    }

    $yytitle .= qq~ $quiztxt{'23'} ~;

$yymain .= qq~
    <form action="$adminurl?action=quizsettings2" method="post" name="creator">
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg">$admin_img{'prefimg'} <b>$quiztxt{'mod'}</b></td>
            </tr><tr>
                <td class="catbg"><span class="small">$quiztxt{'author'} <i>$quiztxt{'authorlist'}</i></span></td>
            </tr>
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <colgroup>
                <col style="width:40%" />
                <col style="width:60%" />
            </colgroup>
            <tr>
                <td class="titlebg" colspan="2">$admin_img{'prefimg'} <b>$quiztxt{'1'}</b></td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'24'}</b></td>
                <td class="windowbg2">
                    <input type="text" name="QuizzesPerPage" size="3" value="$QuizzesPerPage" />
                </td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'115'}</b></td>
                <td class="windowbg2">
                    <input type="text" name="QuizMaxDecrpChars" size="3" value="$QuizMaxDecrpChars" />
                </td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'112'}</b></td>
                <td class="windowbg2">
                    <input type="text" name="QuizMaxQuestChars" size="3" value="$QuizMaxQuestChars" />
                </td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'25'}</b></td>
                <td class="windowbg2">
                    <input type="text" name="QuizHighScoreLength" size="3" value="$QuizHighScoreLength" />
                </td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'26'}</b></td>
                <td class="windowbg2">
                    <input type="text" name="QuizMinQuestions" size="3" value="$QuizMinQuestions" />
                </td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'103'}</b></td>
                <td class="windowbg2">
                    <input type="checkbox" name="QuizSetTimelimit" $QuizSetTimelimitChk />
                </td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'104'}</b></td>
                <td class="windowbg2">
                    <input type="text" name="QuizMaxTimelimit" size="4" value="$QuizMaxTimelimit" />
                </td>
            </tr><tr>
                <td class="windowbg2"><b>$quiztxt{'116'}</b></td>
                <td class="windowbg2">
                    <input type="checkbox" name="QuizGuestTab" $QuizGuestTabChk />
                </td>
            </tr>
        </table>
    </div>
    <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <td class="titlebg" colspan="3">
                    $admin_img{'prefimg'} <b>$quiztxt{'110'}</b>
                </td>
            </tr><tr>
                <td class="windowbg2" colspan="3">
                    <span class="small">$quiztxt{'111'}<br />$admin_txt{'14'}</span>
                </td>
            </tr><tr>
                <td class="catbg center"><b>$quiztxt{'2'}</b></td>
                <td class="catbg center"><b>$quiztxt{'27'}</b></td>
                <td class="catbg center"><b>$quiztxt{'29'}</b></td>
            </tr><tr>
                <td class="windowbg2 center">
                    <select multiple="multiple" name="QuizAddGroups" size="$k">$box</select><br />
                </td>
                <td class="windowbg2 center">
                    <select multiple="multiple" name="QuizModGroups" size="$k">$modbox</select><br />
                </td>
                <td class="windowbg2 center">
                    <select multiple="multiple" name="QuizDelGroups" size="$k">$delbox</select><br />
                </td>
            </tr>
        </table>
        </div>
        <div class="bordercolor rightboxdiv">
        <table class="border-space pad-cell" style="margin-bottom: .5em;">
            <tr>
                <th class="titlebg">$admin_img{'prefimg'} $admin_txt{'10'}</th>
            </tr><tr>
                <td class="catbg center"><input type="submit" value="$admin_txt{'10'}" /></td>
            </tr>
        </table>
    </div>
    </form>
~;

$action_area = 'quizsettings';
AdminTemplate();
exit;
}

sub quizsettings2 {

if (!$iamadmin) {
    fatal_error($error_txt{'no_access'});
}

my @onoff = qw/QuizSetTimelimit QuizGuestTab/;
my $fi;
map { $fi = $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;

if($FORM{'QuizAddGroups'}) { $QuizAddAllMembers = 0; } else { $QuizAddAllMembers = 1; }
if($FORM{'QuizModGroups'}) { $QuizModifyAllMembers = 0; } else { $QuizModifyAllMembers = 1; }
if($FORM{'QuizDelGroups'}) { $QuizDeleteAllMembers = 0; } else { $QuizDeleteAllMembers = 1; }

fopen(FILE, ">$vardir/quiz2.txt");
print FILE qq~
\$QuizHighScoreLength = $FORM{'QuizHighScoreLength'};
\$QuizzesPerPage = $FORM{'QuizzesPerPage'};
\$QuizMinQuestions = $FORM{'QuizMinQuestions'};
\$QuizAddGroups = "$FORM{'QuizAddGroups'}";
\$QuizModGroups = "$FORM{'QuizModGroups'}";
\$QuizDelGroups = "$FORM{'QuizDelGroups'}";
\$QuizAddAllMembers = $QuizAddAllMembers;
\$QuizModifyAllMembers = $QuizModifyAllMembers;
\$QuizDeleteAllMembers = $QuizDeleteAllMembers;
\$QuizSetTimelimit = $QuizSetTimelimit;
\$QuizMaxTimelimit = $FORM{'QuizMaxTimelimit'};
\$QuizMaxQuestChars = $FORM{'QuizMaxQuestChars'};
\$QuizMaxDecrpChars = $FORM{'QuizMaxDecrpChars'};
\$QuizGuestTab = $QuizGuestTab;\n
1;~;
fclose(FILE);

require "$vardir/quiz2.txt";
WriteLog();
$yySetLocation = qq~$adminurl?action=quizsettings~;
redirectexit();
}

1;