#-------------------------------------------------------------------#
# Quiz.pm                                                           #
#-------------------------------------------------------------------#
# Quiz for YaBB 2.6.0                                               #
# Version 0.7.4                                                     #
#-------------------------------------------------------------------#
use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.6.0';

$quizpmver = 'YaBB 2.6.0 $Revision: 0.7.4 $';
if ( $action eq 'detailedversion' ) { return 1; }

require "$vardir/quiz2.txt";
if ( $iamguest && !$QuizGuestTab ) { fatal_error('members_only'); }

$QuizBar = "$modimgurl/quiz/QuizBar.gif";
LoadLanguage('Post');
LoadLanguage('Quiz');

require Sources::DateTime;

if ( !-e ("$vardir/quiz2.txt") ) {
    fopen( FILE, ">>$vardir/quiz2.txt" );
    print {FILE}
"\$QuizHighScoreLength = 5;\n\$QuizzesPerPage = 10;\n\$QuizMinQuestions = 10;\n\$QuizAddGroups = '';\n\$QuizModGroups = '';\n\$QuizDelGroups = '';\n\$QuizAddAllMembers = 1;\n\$QuizModifyAllMembers = 1;\n\$QuizDeleteAllMembers = 1;\n\$QuizSetTimelimit = 1;\n\$QuizMaxTimelimit = 120;\n\$QuizMaxQuestChars = 500;\n\$QuizMaxDecrpChars = 500;\n\$QuizGuestTab = 1;\n\n1;" or croak "$croak{'print'} quiz";
    fclose(FILE);
}
if ( !$QuizMaxQuestChars ) { $QuizMaxQuestChars = 500; }
if ( !$QuizMaxDecrpChars ) { $QuizMaxDecrpChars = 500; }

sub quizmain {
    require "$vardir/quiz2.txt";

    $yytitle .= qq~ $quiztxt{'4'} ~;
    $yynavigation = qq~&rsaquo; $quiztxt{'4'}~;
    $date2        = $date;

    opendir QUIZFILES, $vardir;
    @quizfile = grep { /[.]quiz$/xsm } readdir QUIZFILES;
    closedir QUIZFILES;

    # Create quizlist
    $membquizcount = 0;
    if ( -e ("$memberdir/$username.quiz") ) {
        fopen( FILE, "$memberdir/$username.quiz" );
        @membquiz = <FILE>;
        fclose(FILE);

        foreach my $i (@membquiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        $membquizcount = @membquiz;
    }

    $x = 0;
    for my $quizname (@quizfile) {
        chomp $quizname;
        fopen( QUIZFILE, "$vardir/$quizname" );
        @quiz = <QUIZFILE>;
        fclose(QUIZFILE);
        for my $i (@quiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        chomp @quiz;
        $quizname =~ s/[.]quiz$//gsm;
        $quiztitle              = $quiz[0];
        $quizimage              = $quiz[1];
        $quizcreatorname        = $quiz[2];
        $quizcreatordisplayname = $quiz[3];
        my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

        $solvestate = 0;

        for my $i ( 0 .. ( $membquizcount - 1 ) ) {
            my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
              split /[|]/xsm, $membquiz[$i];
            if ( $tmp_quizname eq $quizname ) {
                if ( $tmp_quizposition == $quizquestionnumber ) {
                    $solvestate = 2;
                }
                else {
                    $solvestate = 1;
                }
            }
        }

        LoadUser($quizcreatorname);
        if ( ${ $uid . $quizcreatorname }{'realname'} ) {
            $quizprofile = qq~$link{$quizcreatorname}~;
        }
        else {
            $quizprofile = "$quizcreatordisplayname";
        }
        $quizdescription = $quiz[4];
        $quiztimes       = $quiz[5];
        $quizaverage     = $quiz[6];
        $quizdifficulty  = 0.1 * int( ( 100 - $quiz[6] ) * 0.5 );
        if ( $quiztimes == 0 ) { $quizdifficulty = q{-}; }
        if ( $quiz[8] =~
            m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
        {
            $quiz[8] = stringtotime( $quiz[8] );
        }
        $date1 = $quiz[8];
        calcdifference();
        $days_reg = $result;
        if (   ( $quizquestionnumber >= $QuizMinQuestions && $ispublic )
            || $quizcreatorname eq $username
            || $iamadmin )
        {
            $tmplist[$x] =
qq~$quizname|$quiztitle|$quizimage|$quizcreatorname|$quizcreatordisplayname|$quizprofile|$quizdescription|$quiztimes|$quizdifficulty|$quizquestionnumber|$date1|$days_reg|$solvestate|$ispublic~;
            $x++;
        }
    }

    $quizcount = @tmplist;

    if ( !$quizcount ) {
        $heading = qq~$quiztxt{'89'}~;
    }
    else {
        $sortmode  = $INFO{'sort'};
        $sortorder = $INFO{'order'};

        $selName = q~class="windowbg2"~;
        $selCrea = q~class="windowbg2"~;
        $selDiff = q~class="windowbg2"~;
        $selNumb = q~class="windowbg2"~;
        $selTime = q~class="windowbg2"~;
        $selDate = q~class="windowbg2"~;

        if ( $sortmode eq 'name' ) {
            @sortlist =
              map  { $_->[0] }
              sort { uc( $a->[2] ) cmp uc( $b->[2] ) }
              map  { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmplist);
            $selName = q~class="windowbg"~;
        }
        elsif ( $sortmode eq 'creator' ) {
            @sortlist = map { $_->[0] } sort {
                     uc( $b->[4] ) cmp uc( $a->[4] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 4 ] ] } (@tmplist);
            $selCrea = q~class="windowbg"~;
        }
        elsif ( $sortmode eq 'difficulty' ) {
            @sortlist = map { $_->[0] } sort {
                ( $b->[9] ) <=> ( $a->[9] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 9 ] ] } (@tmplist);
            $selDiff = q~class="windowbg"~;
        }
        elsif ( $sortmode eq 'num' ) {
            @sortlist = map { $_->[0] } sort {
                ( $b->[10] ) <=> ( $a->[10] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 10 ] ] } (@tmplist);
            $selNumb = q~class="windowbg"~;
        }
        elsif ( $sortmode eq 'times' ) {
            @sortlist = map { $_->[0] } sort {
                ( $b->[8] ) <=> ( $a->[8] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 8 ] ] } (@tmplist);
            $selTime = q~class="windowbg"~;
        }
        elsif ( $sortmode eq 'date' ) {
            @sortlist = map { $_->[0] } sort {
                ( $a->[11] ) <=> ( $b->[11] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 11 ] ] } (@tmplist);
            $selDate = q~class="windowbg"~;
        }
        else {
            @sortlist =
              map  { $_->[0] }
              sort { uc( $a->[2] ) cmp uc( $b->[2] ) }
              map  { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmplist);
            $selName = q~class="windowbg"~;
        }

        if ( $INFO{'order'} eq 'reverse' ) {
            @sortlist = reverse @sortlist;
        }
        else {
            if ( $sortmode eq 'name' ) {
                $order_name = ';order=reverse';
            }
            elsif ( $sortmode eq 'creator' ) {
                $order_creator = ';order=reverse';
            }
            elsif ( $sortmode eq 'difficulty' ) {
                $order_difficulty = ';order=reverse';
            }
            elsif ( $sortmode eq 'num' ) {
                $order_num = ';order=reverse';
            }
            elsif ( $sortmode eq 'times' ) {
                $order_times = ';order=reverse';
            }
            elsif ( $sortmode eq 'date' ) {
                $order_date = ';order=reverse';
            }
        }

        if ( $sortmode ne q{} ) {
            $sortmode = ';sort=' . $INFO{'sort'};
        }
        if ( $sortorder ne q{} ) {
            $sortorder = ';order=' . $INFO{'order'};
        }

        # Construct the page links for this board.
        if   ( $INFO{'start'} eq q{} ) { $start = 0; }
        else                          { $start = "$INFO{'start'}"; }
        $numshown = 0;
        $numbegin = ( $start + 1 );
        $numend   = ( $start + $QuizzesPerPage );
        if ( $numend > $quizcount ) { $numend = $quizcount; }
        $bb = $start;

        $indexdisplaynum = 3;    # max number of pages to display
        $startpage       = 0;
        $tmpa            = 1;
        $tmpx = int( $quizcount / $QuizzesPerPage );
        if ( $start >= ( ( $indexdisplaynum - 1 ) * $QuizzesPerPage ) ) {
            $startpage =
              $start - ( ( $indexdisplaynum - 1 ) * $QuizzesPerPage );
            $tmpa = int( $startpage / $QuizzesPerPage ) + 1;
        }
        if ( $quizcount >= $start + ( $indexdisplaynum * $QuizzesPerPage ) ) {
            $endpage = $start + ( $indexdisplaynum * $QuizzesPerPage );
        }
        else { $endpage = $quizcount }
        if ( $startpage > 0 ) {
            $pageindex =
qq~<a href="$scripturl?action=$action;start=0$sortmode$sortorder">1</a>&nbsp;...&nbsp;~;
        }
        if ( $startpage == $QuizzesPerPage ) {
            $pageindex =
qq~<a href="$scripturl?action=$action;start=0$sortmode$sortorder">1</a>&nbsp;~;
        }
        for my $counter ( $startpage .. ( $endpage - 1 ) ) {
            if ( $counter % $QuizzesPerPage == 0 ) {
                $pageindex .=
                $start == $counter && $start ne 'all'
                ? qq~$tmpa ~
                : qq~<a href="$scripturl?action=$action;start=$counter$sortmode$sortorder">$tmpa</a> ~;
                ++$tmpa;
            }
        }
        $tmpx    = $quizcount - 1 - $QuizzesPerPage;
        $outerpn = int( $tmpx / $QuizzesPerPage );
        $lastpn  = int( ( $quizcount - 1 ) / $QuizzesPerPage ) + 1;
        $lastptn = ( $lastpn - 1 ) * $QuizzesPerPage;
        if ( $endpage < $quizcount - $QuizzesPerPage ) {
            $pageindexadd = q~...&nbsp;~;
        }
        if ( $endpage != $quizcount ) {
            $pageindexadd .=
qq~<a href="$scripturl?action=$action;start=$lastptn$sortmode$sortorder">$lastpn</a>&nbsp;~;
        }
        $pageindex .= $pageindexadd;
        if ( $start eq 'all' ) {
            $pageindex .= qq~$quiztxt{'190'}~;
            $QuizzesPerPage = $quizcount;
            $startmode      = q~;start=all~;
            $heading        = qq~$quiztxt{'3'} $quizcount $quiztxt{'4'}~;
        }
        else {
            $pageindex .=
qq~<a href="$scripturl?action=$action;start=all$sortmode$sortorder">$quiztxt{'86'}</a>~;
            $heading =
qq~$quiztxt{'5'} $numbegin $quiztxt{'88'} $numend ($quiztxt{'87'} $quizcount $quiztxt{'6'})~;
        }
    }

    $imgnewquiz = qq~<a href="$scripturl?action=quizadd">$quiztxt{'2'}</a>~;

    my $access = quizaccesscheck('add');

    $yymain .= qq~
    <div class="bordercolor" style="margin-bottom: 8px;">
    <table class="tabtitle tabtitle-text">
        <tr>
            <td style="padding-left:1%">
                <img src="$modimgurl/quiz/quiz.gif" alt="$quiztxt{'4'}" /> $quiztxt{'4'}
            </td>
        </tr>
    </table>
    <table class="pad_4px cs_thin">
        <tr>
            <td class="windowbg2">$heading</td>
~;
    if ($access) {
        $yymain .= qq~
            <td class="windowbg2 center">$imgnewquiz</td>
~;
    }
    $yymain .= q~
        </tr>
    </table>
~;

    if ($quizcount) {
        $yymain .= qq~
        <table class="pad_4px cs_thin">
        <tr>
            <td class="windowbg2 center" style="width:30px">
                &nbsp;
            </td>
            <td $selName>
                <a href="$scripturl?action=quiz$startmode;sort=name$order_name"><b>$quiztxt{'7'}</b></a>
            </td>
            <td $selCrea>
                <a href="$scripturl?action=quiz$startmode;sort=creator$order_creator"><b>$quiztxt{'8'}</b></a>
            </td>
            <td $selDiff>
                <a href="$scripturl?action=quiz$startmode;sort=difficulty$order_difficulty"><b>$quiztxt{'9'}</b></a>
            </td>
            <td $selNumb>
                <a href="$scripturl?action=quiz$startmode;sort=num$order_num"><b>$quiztxt{'10'}</b></a>
            </td>
            <td $selTime>
                <a href="$scripturl?action=quiz$startmode;sort=times$order_times"><b>$quiztxt{'12'}</b></a>
            </td>
            <td $selDate>
                <a href="$scripturl?action=quiz$startmode;sort=date$order_date"><b>$quiztxt{'11'}</b></a>
            </td>
        </tr>
~;

        while ( $numshown < $QuizzesPerPage ) {
            $numshown++;
            (
                $quizname,               $quiztitle,
                $quizimage,              $quizcreatorname,
                $quizcreatordisplayname, $quizprofile,
                $quizdescription,        $quiztimes,
                $quizdifficulty,         $quizquestionnumber,
                $quizposted,             $days_reg,
                $solvestate,             $ispublic
            ) = split /[|]/xsm, $sortlist[$bb];
            $quizposted = timeformat($quizposted);

            if ( !$quizname ) { next; }

            $yymain .= q~<tr>
                <td class="windowbg center">
~;
            if ( $solvestate == 2 ) {
                $yymain .=
qq~<img src="$modimgurl/quiz/chekgreen.gif" alt="$quiztxt{'70'}" />~;
            }
            elsif ( $solvestate == 1 ) {
                $yymain .=
qq~<img src="$modimgurl/quiz/chekyellow.gif" alt="$quiztxt{'71'}" />~;
            }
            if (   ( $quizcreatorname eq $username || $iamadmin )
                && ( $quizquestionnumber < $QuizMinQuestions || !$ispublic ) )
            {
                $yymain .=
                  qq~<img src="$imagesdir/red1.gif" alt="$quiztxt{'30'}" />~;
            }
            if (   $quizcreatorname eq $username
                && $quizquestionnumber >= $QuizMinQuestions
                && $ispublic )
            {
                $yymain .=
                  qq~<img src="$imagesdir/green1.gif" alt="$quiztxt{'90'}" />~;
            }
            $yymain .= qq~
                </td>
                <td class="windowbg"><a href="$scripturl?action=quizdisplay;name=$quizname">$quiztitle</a></td>
                <td class="windowbg">$quizprofile</td>
                <td class="windowbg">$quizdifficulty</td>
                <td class="windowbg">$quizquestionnumber</td>
                <td class="windowbg">$quiztimes</td>
                <td class="windowbg">$quizposted</td>
            </tr>~;
            $bb++;
        }

        $yymain .= qq~
        </table>
        <table class="pad_4px cs_thin">
            <tr>
                <td class="catbg">
                    <span class="small">$quiztxt{'85'}: $pageindex</span>
                </td>
            </tr>
        </table>
~;
    }

    $yymain .= q~
    </div>
~;

    template();
    exit;
}

sub quizdisplay {

    require "$vardir/quiz2.txt";

    $quizname = $INFO{'name'};
    $date2    = $date;

    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    $quizimage              = $quiz[1];
    $quizcreatordisplayname = $quiz[3];
    $quizcreatorname        = $quiz[2];
    $quizdescription        = $quiz[4];
    $quizdifficulty         = 0.1 * int( ( 100 - $quiz[6] ) * 0.5 );

    if ( $quiz[5] == 0 ) { $quizdifficulty = q{-} }

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    my $ispubcheck = q{};
    if ($ispublic) {
        $ispubcheck = q~checked="checked"~;
    }

    # no html code in description
    $quizdescription = clean1($quizdescription);

    # censor quiz description
    LoadCensorList();
    for (@censored) {
        my ( $tmpa, $tmpb ) = @{$_};
        $quizdescription =~ s/\Q$tmpa\E/$tmpb/gism;
    }

    # do YaBBC  on the quiz description
    $message = $quizdescription;
    if ($enable_ubbc) {
        enable_yabbc();
        DoUBBC();
    }
    $quizdescription = $message;

    LoadUser($quizcreatorname);

    if ( ${ $uid . $quizcreatorname }{'realname'} ) {
        $quizprofile = qq~$link{$quizcreatorname}~;
    }
    else {
        $quizprofile = "$quizcreatordisplayname";
    }

    if ( $quiz[8] =~
        m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
    {
        $quiz[8] = stringtotime( $quiz[8] );
    }

    $quizposted = timeformat( $quiz[8] );

    $questionnumber = 1;

    if ( -e ("$memberdir/$username.quiz") ) {
        fopen( FILE, "$memberdir/$username.quiz" );
        @membquiz = <FILE>;
        fclose(FILE);

        for my $i (@membquiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }

        $membquizcount = @membquiz;

        for my $i ( 0 .. ( $membquizcount - 1 ) ) {
            $quest_open[$i] = 'disabled';
            my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
              split /[|]/xsm, $membquiz[$i];
            if ( $tmp_quizname eq $quizname ) {
                $questionnumber = $tmp_quizposition;
                $questionnumber++;
            }
        }
    }

    $yytitle .= qq~ $quiz[0] ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo; $quiz[0]~;

    $imgquestionadd =
qq~<a href="$scripturl?action=quizquestionadd;name=$quizname">$img{'imgquestionadd'}</a>~;
    $imgquizmake =
qq~<a href="$scripturl?action=quizquestion;name=$quizname">$img{'imgquizmake'}</a>~;
    $imgmodify =
qq~<a href="$scripturl?action=quizmodify;name=$quizname">$img{'imgmodify'}</a>~;
    $imgremovequiz =
qq~<span style="cursor: pointer;" onclick="if (confirm('$quiztxt{'32'} $quiz[0]')) location.href = '$scripturl?action=quizdelete;name=$quizname;q=1'">$img{'imgremovequiz'}</span>~;
    $imgquizhome = qq~<a href="$scripturl?action=quiz">$img{'imgquizhome'}</a>~;

    $yymain .= qq~
    <div style="margin-bottom: 8px;">
        <table class="pad_4px cs_thin">
            <tr>
                <td class="catbg">$quiz[0]</td>
            </tr><tr>
                <td class="windowbg2">
                    <div style="float: left; width: 20%; margin-bottom: 6px;"><b>$quiztxt{'18'} $z:</b></div>
                    <div style="float: left; width: 79%; margin-bottom: 6px;"><img src="$imagesdir/$quiz[1]" alt="" />$quizdescription</div>
                </td>
            </tr>~;

    if ( ( $username eq $quizcreatorname || $iamadmin )
        && $quizquestionnumber > 0 )
    {
        $yymain .= q~<tr>
                <td class="windowbg2">
~;
        $x = 9;
        $z = 1;
        for my $i ( 0 .. ( $quizquestionnumber - 1 ) ) {
            my ( $thisquest, undef ) = split /[|]/xsm, $quiz[$x], 2;

            if ($enable_ubbc) {
                enable_yabbc();
                $message = $thisquest;
                DoUBBC();
                $thisquest = $message;
            }
            $yymain .= qq~
                    <div style="float: left; width: 20%; margin-bottom: 6px;"><b>$quiztxt{'39'} $z:</b></div>
                    <div style="float: left; width: 79%; margin-bottom: 6px;">$thisquest</div>
~;
            $x++;
            $z++;
        }
        $yymain .= q~
                </td>
            </tr>~;
    }

    if ($iamguest) {
        $yymain .= qq~<tr>
                <td class="catbg">
                    $quiztxt{'56'} <a href="$scripturl?action=login">$quiztxt{'57'}</a> $quiztxt{'58'} <a href="$scripturl?action=register">$quiztxt{'59'}</a> $quiztxt{'60'}
                </td>
            </tr>~;
    }
    elsif ( $username ne $quizcreatorname && $questionnumber == 1 && $ispublic )
    {
        $yymain .= qq~<tr>
                <td class="catbg">
                    $imgquizmake
                </td>
            </tr>~;
    }
    elsif ($username ne $quizcreatorname
        && $questionnumber <= $quizquestionnumber
        && $ispublic )
    {
        $yymain .= qq~<tr>
                <td class="catbg">
                    <span class="imgcatbg">$quiztxt{'71'} <a href="$scripturl?action=quizquestion;name=$quizname">$quiztxt{'72'}</a></span>
                </td>
            </tr>~;
    }
    elsif ( $quizcreatorname ne $username && $ispublic ) {
        $yymain .= qq~<tr>
                <td class="catbg">
                    <span class="imgcatbg">$quiztxt{'70'}</span>
                </td>
            </tr>~;
    }
    elsif ($quizcreatorname eq $username
        && $quizquestionnumber < $QuizMinQuestions )
    {
        $yymain .= qq~<tr>
                <td class="windowbg2">
                    <span class="small">$quiztxt{'95'} $QuizMinQuestions $quiztxt{'96'}</span>
                </td>
            </tr>~;
    }
    elsif ( ( $quizcreatorname eq $username || $iamadmin )
        && $quizquestionnumber >= $QuizMinQuestions )
    {
        if ( !$ispublic ) {
            $releaseinfo = qq~$quiztxt{'99'}~;
        }
        else {
            $releaseinfo = qq~$quiztxt{'100'}~;
        }
        $yymain .= qq~<tr>
                <td class="windowbg2">
                    <div style="float: left; width: 30%; margin-bottom: 6px;">
                        <b>$quiztxt{'98'}</b><br />
                        <span class="small">$releaseinfo</span>
                    </div>
                    <div style="float: left; width: 69%; margin-bottom: 6px;">
                        <form action="$scripturl?action=quizrelease" name="releasequiz" method="post">
                        <input type="hidden" name="quizname" value="$quizname" />
                        <input type="checkbox" name="QuizRelease" class="windowbg2" style="border: 0;" $ispubcheck />
                        <input type="submit" class="button" value="$maintxt{'32'}" />
                        </form>
                    </div>
                </td>
            </tr>~;
    }

    $yymain .= qq~
        </table>
    </div>
    <div style="margin-bottom: 8px;">
        <table class="pad_4px cs_thin">
            <tr>
                <td class="catbg">$quiztxt{'13'}</td>
            </tr><tr>
                <td class="windowbg2">
                    <table>
                        <tr>
                            <td>$quiztxt{'21'}:</td>
                            <td>$quizprofile</td>
                        </tr><tr>
                            <td>$quiztxt{'11'}:</td>
                            <td>$quizposted</td>
                        </tr><tr>
                            <td>$quiztxt{'10'}:</td>
                            <td>$quizquestionnumber</td>
                        </tr><tr>
                            <td>$quiztxt{'12'}:</td>
                            <td>$quiz[5]</td>
                        </tr><tr>
                            <td>$quiztxt{'9'}:</td>
                            <td>$quizdifficulty</td>
                        </tr>
                    </table>
                </td>
            </tr><tr>
                <td class="catbg">
~;
    my $access = quizaccesscheck('add');
    if (   $access
        && ( $iamadmin || $username eq $quizcreatorname )
        && !$ispublic )
    {
        $yymain .= qq~ $imgquestionadd $menusep ~;
    }
    $access = quizaccesscheck('mod');
    if ( $access && !$ispublic ) {
        $yymain .= qq~ $imgmodify $menusep ~;
    }
    $access = quizaccesscheck('del');
    if ($access) {
        $yymain .= qq~ $imgremovequiz $menusep ~;
    }

    $yymain .= qq~
                    $imgquizhome
                </td>
            </tr>
        </table>
    </div>
~;

    # Load Quiz Highscore
    fopen( FILE, "$vardir/$quizname.quizresult" );
    @quizscorelist = <FILE>;
    fclose(FILE);
    chomp @quizscorelist;
    $quizscores = @quizscorelist;
    $i          = 0;
    $x          = 0;
    while ( $i < $quizscores ) {
        my ( $tmp_username, $tmp_score, $tmp_date ) = split /[|]/xsm,
          $quizscorelist[$i];
        chomp $tmp_date;
        if ( !$tmp_date ) { $i++; next; }

        if ( $tmp_date =~
            m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
        {
            $tmp_date = stringtotime($tmp_date);
        }

        $date1 = $tmp_date;
        calcdifference();
        $days_reg = $result;
        $tmpquizscorelist[$x] =
          qq~$tmp_username|$tmp_score|$tmp_date|$days_reg~;
        $x++;
        $i++;
    }

    $quizscores = @tmpquizscorelist;

    # Sort quizscorelist by highscore

    @sortscorelist =
      map { $_->[0] }
      sort { ( $b->[2] ) <=> ( $a->[2] ) || uc( $a->[0] ) cmp uc( $b->[0] ) }
      map { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmpquizscorelist);

    $highscorelength = $QuizHighScoreLength;

    if ( $INFO{'sort'} eq 'high' )        { $highscorelength = $quizscores; }
    if ( $highscorelength > $quizscores ) { $highscorelength = $quizscores; }
    if ( $INFO{'sort'} eq 'latest' )      { $highscorelength = 0; }

    if ( $highscorelength > 0 ) {
        $yymain .= qq~
            <div style="margin-bottom: 8px;">
                <div style="float: left; width: 49%;">
                <table class="pad_4px cs_thin">
                <tr>
                    <td colspan="3" class="catbg center">$quiztxt{'19'}</td>
                </tr><tr>
                    <td class="titlebg">$quiztxt{'14'}</td>
                    <td class="titlebg">$quiztxt{'15'}</td>
                    <td class="titlebg">$quiztxt{'16'}</td>
                </tr>
~;

        for my $i ( 0 .. ( $highscorelength - 1 ) ) {
            my ( $tmp_username, $highscore, $tmp_date, $days_reg ) =
              split /[|]/xsm, $sortscorelist[$i];
            $tmp_date = timeformat($tmp_date);

            LoadUser($tmp_username);
            $tmp_userprofile = qq~$link{$tmp_username}~;
            $yymain .= qq~<tr>
                        <td class="windowbg2">$tmp_userprofile</td>
                        <td class="windowbg2">$highscore</td>
                        <td class="windowbg2">$tmp_date</td>
                    </tr>~;
        }

        if ( $highscorelength < $quizscores ) {
            $yymain .= qq~<tr>
                        <td colspan="3" class="catbg">
                            <a href="$scripturl?action=quizdisplay;name=$quizname;sort=high">$quiztxt{'17'}</a>
                        </td>
                    </tr>~;
        }
        $yymain .= q~
                </table>
            </div>
~;
    }

    # Sort quizscorelist by date
    @sortscorelist =
      map { $_->[0] }
      sort { ( $a->[4] ) <=> ( $b->[4] ) || uc( $a->[0] ) cmp uc( $b->[0] ) }
      map { [ $_, ( split /[|]/xsm )[ 0 .. 4 ] ] } (@tmpquizscorelist);

    $highscorelength = $QuizHighScoreLength;

    if ( $INFO{'sort'} eq 'latest' ) {
        $highscorelength = $quizscores;
    }
    if ( $highscorelength > $quizscores ) {
        $highscorelength = $quizscores;
    }
    if ( $INFO{'sort'} eq 'high' ) {
        $highscorelength = 0;
    }

    if ( $highscorelength > 0 ) {
        $yymain .= qq~
            <div style="float: right; width: 49%;">
                <table class="pad_4px cs_thin">
                <tr>
                    <td colspan="3" class="catbg center">$quiztxt{'20'}</td>
                </tr><tr>
                    <td class="titlebg">$quiztxt{'14'}</td>
                    <td class="titlebg">$quiztxt{'15'}</td>
                    <td class="titlebg">$quiztxt{'16'}</td>
                </tr>~;

        for my $i ( 0 .. ( $highscorelength - 1 ) ) {
            my ( $tmp_username, $highscore, $tmpdate, $reg_days ) =
              split /[|]/xsm, $sortscorelist[$i];
            $tmpdate = timeformat($tmpdate);

            LoadUser($tmp_username);
            $tmp_userprofile = qq~$link{$tmp_username}~;

            $yymain .= qq~<tr>
                        <td class="windowbg2">$tmp_userprofile</td>
                        <td class="windowbg2">$highscore</td>
                        <td class="windowbg2">$tmpdate</td>
                    </tr>~;
        }

        if ( $highscorelength < $quizscores ) {
            $yymain .= qq~<tr>
                        <td colspan="3" class="catbg">
                            <a href="$scripturl?action=quizdisplay;name=$quizname;sort=latest">$quiztxt{'17'}</a>
                        </td>
                    </tr>~;
        }
        $yymain .= q~
                </table>
            </div>
        </div>
~;
    }

    template();
    exit;
}

sub quizrelease {

    $quizname = $FORM{'quizname'};
    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);
    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;
    $quiztitle       = $quiz[0];
    $quizcreatorname = $quiz[2];
    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    if ( $quizcreatorname ne $username && !$iamadmin ) {
        fatal_error('quiz_norelease');
    }

    if (   ( !$FORM{'QuizRelease'} && !$ispublic )
        || ( $FORM{'QuizRelease'} && $ispublic ) )
    {
        WriteLog();
        $yySetLocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
        redirectexit();
    }
    elsif ( $FORM{'QuizRelease'} ) {
        $ispublic = 1;
        $quiz[7] = qq~$quizquestionnumber|$ispublic~;
    }
    elsif ( !$FORM{'QuizRelease'} ) {
        $ispublic = 0;
        $quiz[7]  = qq~$quizquestionnumber|$ispublic~;
        $quiz[5]  = 0;
        $quiz[6]  = 0;

        fopen( RESFILE, "$vardir/$quizname.quizresult" );
        @quizres = <RESFILE>;
        fclose(RESFILE);
        for my $i (@quizres) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        chomp @quizres;

        for my $restring (@quizres) {
            my ( $tmpusername, undef ) = split /[|]/xsm, $restring, 2;

            fopen( FILE, "$memberdir/$tmpusername.quiz" );
            @membquiz = <FILE>;
            fclose(FILE);
            for my $i (@membquiz) {
                $i =~ tr/\r//d;
                $i =~ tr/\n//d;
            }
            chomp @membquiz;

            $i = 0;
            fopen( FILE, ">$memberdir/$tmpusername.quiz" );
            for my $memstring (@membquiz) {
                ( $tmpquizname, undef ) = split /[|]/xsm, $memstring, 2;
                if ( $tmpquizname ne $quizname ) {
                    print {FILE} "$membquiz[$i]\n" or croak "$croak{'print'} FILE";
                }
                $i++;
            }
            fclose(FILE);

            fopen( FILE, "$memberdir/$tmpusername.quizlog" );
            @memblquiz = <FILE>;
            fclose(FILE);
            for my $i (@memblquiz) {
                $i =~ tr/\r//d;
                $i =~ tr/\n//d;
            }
            chomp @memblquiz;

            $i = 0;
            fopen( FILE, ">$memberdir/$tmpusername.quizlog" );
            for my $memlstring (@memblquiz) {
                ( $tmpquizlname, undef ) = split /[|]/xsm, $memlstring, 2;
                if ( $tmpquizlname ne $quizname ) {
                    print {FILE} "$memblquiz[$i]\n" or croak "$croak{'print'} FILE";
                }
                $i++;
            }
            fclose(FILE);

            if ( !-s "$memberdir/$tmpusername.quiz" ) {
                unlink "$memberdir/$tmpusername.quiz";
            }
            if ( !-s "$memberdir/$tmpusername.quizlog" ) {
                unlink "$memberdir/$tmpusername.quizlog";
            }
        }

        unlink "$vardir/$quizname.quizresult";
    }

    fopen( FILE, ">$vardir/$quizname.quiz" );
    $quizcount = @quiz;
    for my $i ( 0 .. ( $quizcount - 1 ) ) {
        print {FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
    }
    fclose(FILE);

    WriteLog();
    $yySetLocation = qq~$scripturl?action=quiz~;
    redirectexit();
    return;
}

sub quizdelete {

    $quizname = $INFO{'name'};
    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);
    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;
    $quiztitle       = $quiz[0];
    $quizcreatorname = $quiz[2];

    $access = quizaccesscheck('del');

    if ( !$access ) {
        fatal_error('quiz_nodelete');
    }

    if ( $INFO{'q'} eq '1' ) {
        unlink "$vardir/$quizname.quiz";
        unlink "$vardir/$quizname.quizresult";

        WriteLog();
        $yySetLocation = qq~$scripturl?action=quiz~;
        redirectexit();
    }
    elsif ( $INFO{'q'} eq '0' ) {
        WriteLog();
        $yySetLocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
        redirectexit();
    }
    else {
        $yytitle .= qq~ $quiztxt{'1'} ~;
        $yymain  .= qq~
        <table class="pad_4px cs_thin" style="width:400px">
            <tr>
                <td class="catbg">
                    $quiztxt{'29'}
                </td>
            </tr><tr>
                <td class="windowbg2 center">
                    <br />
                    <b>$quiztxt{'32'} "$quiztitle"?</b>
                    <br /><br />
                </td>
            </tr><tr>
                <td class="catbg center">
                    <a href="$scripturl?action=quizdelete;name=$quizname;q=1">$maintxt{'163'}</a> &nbsp;
                    <a href="$scripturl?action=quizdelete;name=$quizname;q=0">$maintxt{'164'}</a>
                </td>
            </tr>
        </table>
~;
        template();
        exit;
    }
}

sub quizadd {

    require "$vardir/quiz2.txt";

    my $access = quizaccesscheck('add');

    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( !$access ) {
        fatal_error('quiz_noadd');
    }

    $yytitle .= qq~ $quiztxt{'2'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo; $quiztxt{'2'}~;

    $date1      = $date;
    $quizposted = timeformat($date1);

    $yymain .= qq~
    <form action="$scripturl?action=quizadd2" name="postmodify" method="post">
    <input type="hidden" name="username" value="$username" />
    <input type="hidden" name="displayname" value="${$uid.$username}{'realname'}" />
    <input type="hidden" name="posted" value="$date1" />
    <script src="$yyhtml_root/ubbc.js" type="text/javascript"></script>
    <table class="tabtitle tabtitle-text">
        <tr>
            <td style="padding-left:1%"><img src="$yyhtml_root/ModImages/quiz/quiz.gif" alt="$quiztxt{'4'}" /> $quiztxt{'2'}</td>
        </tr>
    </table>
    <table class="bordercolor pad_4px cs_thin">
        <tr>
            <td class="windowbg" style="width:23%"><b>$quiztxt{'7'}:</b></td>
            <td class="windowbg"><input type="text" name="name" size="25" value="" /></td>
        </tr><tr>
            <td class="windowbg"><b>$quiztxt{'21'}:</b></td>
            <td class="windowbg"><a href="$scripturl?action=viewprofile;username=$username">${$uid.$username}{'realname'}</a></td>
        </tr><tr>
            <td class="windowbg"><b>$quiztxt{'11'}:</b></td>
            <td class="windowbg">$quizposted</td>
        </tr>~;

    if ( $enable_ubbc && $showyabbcbutt ) {
        $yymain .= qq~<tr>
            <td class="windowbg2 vtop"><b>$quiztxt{'18'}:</b></td>
            <td class="windowbg2">
~;
        drawEditor($QuizMaxDecrpChars);
        $yymain .= $editmain;
        $yymain .= q~
            </td>
        </tr>~;
    }
    $yymain .= qq~<tr>
            <td colspan="2" class="catbg center"><input type="submit" class="button" value="$post_txt{'10'}" /></td>
        </tr>
    </table>
</form>
~;

    template();
    exit;
}

sub quizadd2 {

    require "$vardir/quiz2.txt";
    $access = quizaccesscheck('add');

    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( !$access ) {
        fatal_error('quiz_noadd');
    }

    $filename        = $FORM{'name'};
    $title           = $FORM{'name'};
    $tmp_username    = $FORM{'username'};
    $tmp_displayname = $FORM{'displayname'};
    $posted          = $FORM{'posted'};
    $descr           = $FORM{'message'};

    $descr = clean1($descr);

    $filename =~ s/\s/_/gsm;
    $filename =~ s/\'//gsm;
    $filename =~ s/\./_/gsm;
    $filename =~ s/\,/_/gsm;
    $filename =~ s/\?/_/gsm;
    $filename =~ s/\!/_/gsm;
    $filename =~ s/\;/_/gsm;
    $filename =~ s/\(/_/gsm;
    $filename =~ s/\)/_/gsm;
    $filename =~ s/\[/_/gsm;
    $filename =~ s/\]/_/gsm;
    $filename =~ s/\{/_/gsm;
    $filename =~ s/\}/_/gsm;
    $filename =~ s/:/_/gsm;
    $filename =~ s/\//_/gsm;
    $filename =~ s/\$/_/gsm;
    $filename =~ s/\+/_/gsm;
    $filename =~ s/\-/_/gsm;
    $filename =~ s/\*/_/gsm;
    $filename =~ s/\&/_/gsm;
    $filename =~ s/\%/_/gsm;
    $filename =~ s/\"/_/gsm;
    $filename =~ s/\#/_/gsm;
    $filename =~ s/\</_/gsm;
    $filename =~ s/\>/_/gsm;
    $filename =~ s/\@/_/gsm;
    $filename =~ s/__/_/gsm;

    if ( length($filename) > 25 ) { $filename = substr $filename, 0, 25; }
    if ( $title eq q{_} || $title eq q{} ) {fatal_error('quiz_noname'); }
    if ( $title eq q{|} ) { fatal_error('quiz_invalname');}
    if ( $filename !~ /\A[0-9A-Za-z_]+\Z/sm ) { fatal_error('quiz_invalname'); }
    if ( $descr eq q{} ) { fatal_error('quiz_nodescription'); }
    if ( -e ("$vardir/$filename.quiz") ) { fatal_error('quiz_nameexsist'); }

    $yymain = q~
        Teststring ~;

    fopen( FILE, ">$vardir/$filename.quiz" );
    print {FILE}
"$title\nblank.gif\n$tmp_username\n$tmp_displayname\n$descr\n0\n0\n0|0\n$FORM{'posted'}\n" or croak "$croak{'print'} FILE";
    fclose(FILE);

    WriteLog();
    $yySetLocation = qq~$scripturl?action=quizquestionadd;name=$filename~;
    redirectexit();
}

sub quizquestionadd {
    require "$vardir/quiz2.txt";
    $quizname = $INFO{'name'};
    $date2    = $date;
    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);
    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    if ($ispublic) {
        fatal_error('quiz_noaddquestion');
    }

    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( $username ne $quiz[2] && !$iamadmin ) {
        fatal_error('quiz_noaddquestion');
    }

    my $access = quizaccesscheck('add');

    if ( !access ) {
        fatal_error('quiz_noaddquestion');
    }

    $yytitle .= qq~ $quiztxt{'28'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quiz[0]</a> &rsaquo;
    $quiztxt{'28'}~;

    $yymain .= qq~
    <form action="$scripturl?action=quizquestionadd2;name=$quizname" method="post" name="postmodify" >
    <script src="$yyhtml_root/ubbc.js" type="text/javascript"></script>
    <table class="tabtitle pad_4px">
        <tr>
            <td><b>$quiz[0]</b></td>
        </tr>
    </table>
    <table class="bordercolor pad_4px cs_thin">
        <tr>
            <td class="titlebg" colspan="2"><b>$quiztxt{'28'}</b></td>
        </tr><tr>
            <td class="windowbg2 vtop" style="width:23%"><b>$quiztxt{'39'}</b></td>
            <td class="windowbg2">
~;

    drawEditor($QuizMaxQuestChars);
    $yymain .= $editmain;

    $yymain .= qq~
            </td>
        </tr><tr>
            <td class="windowbg2" colspan="2"><hr /></td>
        </tr><tr>
            <td class="windowbg2" colspan="2">
                <b>$quiztxt{'91'}</b><br />
                <span class="small">
                    $quiztxt{'45'}<br />
                    $quiztxt{'38'}
                </span>
            </td>
        </tr><tr>
            <td class="windowbg2">
                <b>$quiztxt{'40'}</b> <input type="radio" name="solution" value="1" class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer1" tabindex="2"></textarea>
            </td>
        </tr><tr>
            <td class="windowbg2">
                <b>$quiztxt{'41'}</b> <input type="radio" name="solution" value="2" class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer2" tabindex="3"></textarea>
            </td>
        </tr><tr>
            <td class="windowbg2">
                <b>$quiztxt{'42'}</b> <input type="radio" name="solution" value="3" class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer3" tabindex="4"></textarea>
            </td>
        </tr><tr>
            <td class="windowbg2">
                <b>$quiztxt{'43'}</b> <input type="radio" name="solution" value="4" class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer4" tabindex="5"></textarea>
            </td>
        </tr><tr>
            <td class="windowbg2">
                <b>$quiztxt{'44'}</b> <input type="radio" name="solution" value="5" class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer5" tabindex="6"></textarea>
            </td>
        </tr><tr>
            <td class="windowbg2" colspan="2"><hr /></td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'92'}</b><br />
                <span class="small">
                    $quiztxt{'93'}
                    $quiztxt{'94'}
                </span>
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="4" name="comment" tabindex="7"></textarea><br /><br />
~;
    if ( !$QuestionTimelimit ) { $QuestionTimelimit = 0; }
    if ($QuizSetTimelimit) {
        $yymain .= qq~          </td>
        </tr><tr>
            <td class="windowbg2" colspan="2"><hr /></td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'105'}</b><br />
                <span class="small">$quiztxt{'106'} $QuizMaxTimelimit $quiztxt{'107'}</span>
            </td>
            <td class="windowbg2">
                <input type="text" name="QuestionTimelimit" size="4" value="$QuestionTimelimit" />
            </td>
        </tr>~;
    }
    else {
        $yymain .= q~
                <input type="hidden" name="QuestionTimelimit" value="0" />
            </td>
        </tr>~;
    }
    $yymain .= qq~<tr>
        <td class="catbg center" colspan="2">
            <input type="submit" class="button" value="$post_txt{'10'}" tabindex="8" />
        </td>
    </tr>
    </table>
  </form>
~;

    template();
    exit;
}

sub quizquestionadd2 {

    require "$vardir/quiz2.txt";
    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( !$QuizAddAllMembers && !$iamadmin ) {
        fatal_error('quiz_noadd');
    }

    $quizname = $INFO{'name'};
    chomp $quizname;

    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    if ($ispublic) {
        fatal_error('quiz_noadd');
    }

    if ( $username ne $quiz[2] && !$iamadmin ) {
        fatal_error('quiz_noadd');
    }

    ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    $tmp_question  = $FORM{'message'};
    $tmp_answer1   = $FORM{'answer1'};
    $tmp_answer2   = $FORM{'answer2'};
    $tmp_answer3   = $FORM{'answer3'};
    $tmp_answer4   = $FORM{'answer4'};
    $tmp_answer5   = $FORM{'answer5'};
    $tmp_solution  = $FORM{'solution'};
    $tmp_comment   = $FORM{'comment'};
    $tmp_timelimit = $FORM{'QuestionTimelimit'};

    $tmp_question = clean1($tmp_question);
    $tmp_answer1  = clean1($tmp_answer1);
    $tmp_answer2  = clean1($tmp_answer2);
    $tmp_answer3  = clean1($tmp_answer3);
    $tmp_answer4  = clean1($tmp_answer4);
    $tmp_answer5  = clean1($tmp_answer5);
    $tmp_comment  = clean1($tmp_comment);

    if ( length($tmp_question) == 0 ) { fatal_error('quiz_noquestion'); }

    $tmp_answernumber = 0;
    if ( length($tmp_answer1) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer2) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer3) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer4) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer5) > 0 ) { $tmp_answernumber++ }

    if    ( $tmp_answernumber == 0 ) { fatal_error('quiz_noanswer'); }
    elsif ( $tmp_answernumber == 1 ) { fatal_error('quiz_twoansvers'); }

    if ( length($tmp_solution) == 0 ) { fatal_error('quiz_noradiobutton'); }

    if ( length($tmp_answer1) == 0 && $tmp_solution == 1 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer2) == 0 && $tmp_solution == 2 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer3) == 0 && $tmp_solution == 3 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer4) == 0 && $tmp_solution == 4 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer5) == 0 && $tmp_solution == 5 ) {
        fatal_error('quiz_emptysolution');
    }

    if ( $tmp_timelimit =~ /\D/sm ) { fatal_error('quiz_timelimitnumb'); }
    if ( $tmp_timelimit > $QuizMaxTimelimit ) {
        $tmp_timelimit = $QuizMaxTimelimit;
    }

    $quizquestionnumber++;

    $quiz[7] = qq~$quizquestionnumber|$ispublic~;

    fopen( FILE, ">$vardir/$quizname.quiz" );
    $quizcount = @quiz;
    for my $i ( 0 .. ( $quizcount - 1 ) ) {
        print {FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
    }
    print {FILE}
"$tmp_question|$tmp_solution|$tmp_answer1|$tmp_answer2|$tmp_answer3|$tmp_answer4|$tmp_answer5|$tmp_comment|$tmp_timelimit\n" or croak "$croak{'print'} FILE";
    fclose(FILE);

    WriteLog();
    $yySetLocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
    redirectexit();
    return;
}

sub quizquestion {

    require "$vardir/quiz2.txt";
    if ($iamguest) { fatal_error('quiz_loginorreg'); }

    $quizname = $INFO{'name'};
    chomp $quizname;

    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    chomp @quiz;

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    $questionnumber = 1;

    if ( -e ("$memberdir/$username.quiz") ) {
        fopen( FILE, "$memberdir/$username.quiz" );
        @membquiz = <FILE>;
        fclose(FILE);

        for my $i (@membquiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }

        $membquizcount = @membquiz;
        for my $i ( 0 .. ( $membquizcount - 1 ) ) {
            my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
              split /[|]/xsm, $membquiz[$i];
            if ( $tmp_quizname eq $quizname ) {
                $questionnumber = $tmp_quizposition;
                $questionnumber++;
            }
        }
    }

    if ( $questionnumber > $quizquestionnumber ) {
        fatal_error('quiz_solvedtakeanother');
    }

    $quizcreatorname = $quiz[2];
    $questionstrg    = $quiz[ $questionnumber + 8 ];

    if ( $questionnumber > 1 ) {
        $imgquizhome =
qq~<a href="$scripturl?action=quiz" class="imgcatbg">$quiztxt{'73'}</a>~;
    }
    else {
        $imgquizhome =
qq~<a href="$scripturl?action=quiz" class="imgcatbg">$quiztxt{'74'}</a>~;
    }

    my (
        $question, $solution, $answer1,
        $answer2,  $answer3,  $answer4,
        $answer5,  $comment,  $QuestionTimelimit
    ) = split /[|]/xsm, $questionstrg;

    $question = clean1($question);
    $answer1 = clean1($answer1);
    $answer2 = clean1($answer2);
    $answer3 = clean1($answer3);
    $answer4 = clean1($answer4);
    $answer5 = clean1($answer5);
    $comment = clean1($comment);

    # censor quiz answers and questions
    LoadCensorList();
    foreach (@censored) {
        ( $tmpa, $tmpb ) = @{$_};
        $question =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer1 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer2 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer3 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer4 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer5 =~ s/\Q$tmpa\E/$tmpb/gism;
        $comment =~ s/\Q$tmpa\E/$tmpb/gism;
    }

    if ($enable_ubbc) {
        enable_yabbc();
        $message = $question;
        DoUBBC();
        $question = $message;

        $message = $answer1;
        DoUBBC();
        $answer1 = $message;

        $message = $answer2;
        DoUBBC();
        $answer2 = $message;

        $message = $answer3;
        DoUBBC();
        $answer3 = $message;

        $message = $answer4;
        DoUBBC();
        $answer4 = $message;

        $message = $answer5;
        DoUBBC();
        $answer5 = $message;

        $message = $comment;
        DoUBBC();
        $comment = $message;
    }

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quiz[0]</a> &rsaquo;
    $quiztxt{'39'} $questionnumber ~;

    $yytitle .= qq~ $quiz[0] $quiztxt{'39'} $questionnumber~;

    $yymain .= qq~
    <form action="$scripturl?action=quizquestion2;name=$quizname" method="post">
    <input type="hidden" name="questionnumber" value="$questionnumber" />

    <div class="bordercolor" style="padding: 1px; width: 100%; margin-left: auto; margin-right: auto;">
    <table class="pad_4px cs_thin">
        <tr>
            <td class="titlebg center"><b>$quiz[0]</b></td>
        </tr><tr>
            <td class="catbg"><b>$quiztxt{'39'} $questionnumber</b></td>
        </tr><tr>
            <td class="windowbg">$question</td>
        </tr>~;
    if ( $QuestionTimelimit > 0 && $QuizSetTimelimit ) {
        $yymain .= qq~<tr>
            <td class="windowbg">
                <div class="windowbg" style="position:relative; width: 300px; height: 12px; border: 2px inset; visibility: visible;">
                    <div class="windowbg2" style="position: absolute; top: 0; left: 0; width: 300px; height: 12px; font-size: 1px;"></div>
                    <div class="titlebg" id="tbar" style="position: absolute; top: 0; left: 0; width: 0px; height: 12px; font-size: 1px;"></div>
                </div>
                <div class="windowbg" style="float: left;">
                    $quiztxt{'109'}
                    <input type="text" name="remtime" id="remtime" size="4" value="$QuestionTimelimit" readonly="readonly" class="windowbg" style="border: 0;" />
                </div>
                <script type="text/javascript">
            var duration = $QuestionTimelimit;
            var stepsize = 300/duration/10;
            var timerem = duration*10;
            var done = 0;
            var starter = setInterval('incrBar()', 100);

            var action=function() {
                window.location="$scripturl?action=quizquestion2;name=$quizname;questionnumber=$questionnumber";
            }

            function incrBar() {
                done++;
                if(done < 0) done = 0;
                if(done >= duration * 10){
                    clearInterval(starter);
                    done = duration * 10;
                    setTimeout('action()', 100);
                }
                document.getElementById('tbar').style.width = stepsize*done+'px';
                document.getElementById('remtime').value = parseInt(timerem/10);
                timerem--;
            }
                </script>
            </td>
        </tr>~;
    }

    if ( length($answer1) > 0 ) {
        $yymain .= qq~<tr>
            <td class="windowbg2">
                <input type=radio class="windowbg2" name="answer" id="answer1" value="1" style="border: 0; vertical-align: middle;" />
                <label for="answer1">$answer1</label>
            </td>
        </tr>~;
    }
    if ( length($answer2) > 0 ) {
        $yymain .= qq~<tr>
            <td class="windowbg2">
                <input type=radio class="windowbg2" name="answer" id="answer2" value="2" style="border: 0; vertical-align: middle;" />
                <label for="answer2">$answer2</label>
            </td>
        </tr>~;
    }
    if ( length($answer3) > 0 ) {
        $yymain .= qq~<tr>
            <td class="windowbg2">
                <input type=radio class="windowbg2" name="answer" id="answer3" value="3" style="border: 0; vertical-align: middle;" />
                <label for="answer3">$answer3</label>
            </td>
        </tr>~;
    }
    if ( length($answer4) > 0 ) {
        $yymain .= qq~<tr>
            <td class="windowbg2">
                <input type=radio class="windowbg2" name="answer" id="answer4" value="4" style="border: 0; vertical-align: middle;" />
                <label for="answer4">$answer4</label>
            </td>
        </tr>~;
    }
    if ( length($answer5) > 0 ) {
        $yymain .= qq~<tr>
            <td class="windowbg2">
                <input type=radio class="windowbg2" name="answer" id="answer5" value="5" style="border: 0; vertical-align: middle;" />
                <label for="answer5">$answer5</label>
            </td>
        </tr>~;
    }
    $yymain .= q~<tr>
            <td class="catbg center">
~;
    if ( $questionnumber < $quizquestionnumber ) {
        $yymain .= qq~
        <input type="submit" class="button" value="$quiztxt{'52'}" />
~;
    }
    else {
        $yymain .= qq~
        <input type="submit" class="button" value="$quiztxt{'53'}" />
~;
    }
    $yymain .= qq~
            </td>
        </tr><tr>
            <td class="titlebg">$imgquizhome</td>
        </tr>
    </table>
    </div>
    </form>
~;

    template();
    exit;
}

sub quizquestion2 {

    if ($iamguest) { fatal_error('quiz_loginorreg'); }

    $quizname = $INFO{'name'};
    chomp $quizname;

    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;

    if ( $INFO{'questionnumber'} ) {
        $questionnumber = $INFO{'questionnumber'};
        $answer         = 0;
    }
    else {
        $questionnumber = $FORM{'questionnumber'};
        $answer         = $FORM{'answer'};
    }

    if ( length($answer) == 0 ) { fatal_error('quiz_noanswerselected'); }

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    $questionstrg = $quiz[ $questionnumber + 8 ];
    my (
        $tmp_question, $tmp_solution, $tmp_answer1, $tmp_answer2,
        $tmp_answer3,  $tmp_answer4,  $tmp_answer5, $tmp_comment
    ) = split /[|]/xsm, $questionstrg;
    if   ( $answer == $tmp_solution ) { $tmp_newpoints = 1; }
    else                              { $tmp_newpoints = 0; }

    $yourpoints = $tmp_newpoints;
    $isCheat    = 0;

    if ( !-e ("$memberdir/$username.quiz") ) {
        fopen( FILE, ">$memberdir/$username.quiz" );
        print {FILE} "$quizname|1|$tmp_newpoints\n" or croak "$croak{'print'} FILE";
        fclose(FILE);
    }
    else {
        fopen( FILE, "$memberdir/$username.quiz" );
        @membquiz = <FILE>;
        fclose(FILE);

        for my $i (@membquiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }

        chomp @membquiz;
        $membquizcount = @membquiz;

        fopen( FILE, ">$memberdir/$username.quiz" );
        for my $i ( 0 .. ( $membquizcount - 1 ) ) {
            my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
              split /[|]/xsm, $membquiz[$i];
            if ( $tmp_quizname ne $quizname ) {
                print {FILE}
                  "$tmp_quizname|$tmp_quizposition|$tmp_quizpoints\n" or croak "$croak{'print'} FILE";
            }
            else {
                if ( $questionnumber <= $tmp_quizposition ) {
                    $isCheat = 1;
                    print {FILE}
                      "$tmp_quizname|$tmp_quizposition|$tmp_quizpoints" or croak "$croak{'print'} FILE";
                }
                $yourpoints = $tmp_quizpoints + $tmp_newpoints;
            }
        }
        if ( !$isCheat ) {
            print {FILE} "$quizname|$questionnumber|$yourpoints\n" or croak "$croak{'print'} FILE";
        }
        fclose(FILE);
    }

    if ( !$isCheat ) {
        if    ( $answer == 1 ) { $tmp_answertxt = $tmp_answer1; }
        elsif ( $answer == 2 ) { $tmp_answertxt = $tmp_answer2; }
        elsif ( $answer == 3 ) { $tmp_answertxt = $tmp_answer3; }
        elsif ( $answer == 4 ) { $tmp_answertxt = $tmp_answer4; }
        elsif ( $answer == 5 ) { $tmp_answertxt = $tmp_answer5; }
        else                   { $tmp_answertxt = $quiztxt{'102'}; }

        if    ( $tmp_solution == 1 ) { $tmp_solutiontxt = $tmp_answer1; }
        elsif ( $tmp_solution == 2 ) { $tmp_solutiontxt = $tmp_answer2; }
        elsif ( $tmp_solution == 3 ) { $tmp_solutiontxt = $tmp_answer3; }
        elsif ( $tmp_solution == 4 ) { $tmp_solutiontxt = $tmp_answer4; }
        else                         { $tmp_solutiontxt = $tmp_answer5; }

        fopen( QUIZLOGFILE, ">>$memberdir/$username.quizlog" );
        print {QUIZLOGFILE}
"$quizname|$tmp_question|$tmp_answertxt|$tmp_solutiontxt|$tmp_comment\n" or croak "$croak{'print'} FILE";
        fclose(QUIZLOGFILE);

        if ( $questionnumber == 1 ) {
            fopen( FILE, ">>$vardir/$quizname.quizresult" );
            print {FILE} "$username||\n" or croak "$croak{'print'} FILE";
            fclose(FILE);
        }
    }

    if ( $quizquestionnumber == $questionnumber ) {
        quizresult();
    }
    else {
        if   ($isCheat) { fatal_error('quiz_cheating'); }
        else            { $questionnumber++; }
        quizquestion();
    }
    return;
}

sub quizresult {

    require "$vardir/quiz2.txt";

    $quizname = $INFO{'name'};

    if ($iamguest) { fatal_error('quiz_loginorreg'); }
    if ( !-e ("$memberdir/$username.quiz") ) { fatal_error('quiz_notsolved'); }

    fopen( FILE, "$memberdir/$username.quiz" );
    @membquiz = <FILE>;
    fclose(FILE);

    for my $i (@membquiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    $membquizcount = @membquiz;
    $yourpoints    = 0;

    for my $i ( 0 .. ( $membquizcount - 1 ) ) {
        my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
          split /[|]/xsm, $membquiz[$i];
        if ( $tmp_quizname eq $quizname ) { $yourpoints = $tmp_quizpoints; }
    }

    if ( $yourpoints == -1 ) { fatal_error('quiz_notsolved'); }

    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    # prevent cheat
    # Load Quiz Highscore
    $isCheat = 0;
    fopen( FILE, "$vardir/$quizname.quizresult" );
    @quizscorelist = <FILE>;
    fclose(FILE);
    chomp @quizscorelist;
    $quizscores = @quizscorelist;
    for my $i ( 0 .. ( $quizscores - 1 ) ) {
        my ( $tmp_username, $tmp_score, $tmp_date ) = split /[|]/xsm,
          $quizscorelist[$i];
        if ( $tmp_username eq $username && $tmp_date ) { $isCheat = 1; }
    }

    # end prevent cheat

    if ( $quizquestionnumber == 0 ) { fatal_error('quiz_havenoquestion'); }

    $yourpercent = 100 * $yourpoints / $quizquestionnumber;
    $quiz[6] = ( $quiz[5] * $quiz[6] + $yourpercent ) / ( $quiz[5] + 1 );
    $quiz[5]++;

    if ( !$isCheat ) {
        fopen( FILE, ">$vardir/$quizname.quiz" );
        $quizcount = @quiz;
        for my $i ( 0 .. ( $quizcount - 1 ) ) {
            print {FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
        }
    }

    $quizdisplayname   = $quiz[0];
    $quizaverage       = $quiz[6];
    $quiztimes         = $quiz[5];
    $yourpercentwidth  = int( 3 * $yourpercent + 0.5 );
    $yourpercent       = int( 10 * $yourpercent + 0.5 ) * 0.1;         # round
    $quizaveragewidth  = int( 3 * $quizaverage + 0.5 );
    $quizpercent       = int( 10 * $quizaverage + 0.5 ) * 0.1;         # round
    $quizaveragepoints = $quizaverage * $quizquestionnumber / 100;
    $quizaveragepoints = 0.1 * int( 10 * $quizaveragepoints + 0.5 );

    if ( length($QuizBar) == 0 ) {
        $QuizBar = "$modimgurl/quiz/QuizBar.gif";
    }

    if ( !$isCheat ) {
        fopen( RESFILE, "$vardir/$quizname.quizresult" );
        @quizres = <RESFILE>;
        fclose(RESFILE);
        $quizrescount = @quizres;
        for my $i (@quizres) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        chomp @quizres;

        fopen( FILE, ">$vardir/$quizname.quizresult" );
        for my $i ( 0 .. ( $quizrescount - 1 ) ) {
            my ( $tmpusername, $tmpyourpercent, $tmpdate ) = split /[|]/xsm,
              $quizres[$i];
            if ( $tmpusername ne $username ) {
                print {FILE} "$quizres[$i]\n" or croak "$croak{'print'} FILE";
            }
        }
        print {FILE} "$username|$yourpercent|$date\n" or croak "$croak{'print'} FILE";
        fclose(FILE);
    }

    $imgquizhome = qq~<a href="$scripturl?action=quiz">$img{'imgquizhome'}</a>~;

    $yytitle .= qq~ $quizdisplayname $quiztxt{'61'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quizdisplayname</a> &rsaquo;
    $quiztxt{'61'} ~;

    $yymain .= qq~
    <div style="margin-bottom: 8px;">
    <table class="tabtitle tabtitle-text">
        <tr>
            <td style="padding-left:1%"><img src="$yyhtml_root/ModImages/quiz/quiz.gif" alt="" />$quizdisplayname</td>
        </tr>
    </table>
    <table class="pad_4px cs_thin">
        <tr>
            <td class="catbg">$quiztxt{'61'}</td>
        </tr><tr>
            <td class="windowbg2">
                <table>
                    <tr>
                        <td>
                            $quiztxt{'62'} $yourpoints $quiztxt{'64'} $quizquestionnumber ($yourpercent %)
                        </td>
                    </tr><tr>
                        <td>
                            <div style="width:300px; background-color:#ccc"><img src="$QuizBar" width="$yourpercentwidth" height="10" alt="$yourpercent %" /></div>
                        </td>
                    </tr><tr>
                        <td>
                            $quiztxt{'63'} $quizaveragepoints $quiztxt{'64'} $quizquestionnumber ($quizpercent %)
                        </td>
                    </tr><tr>
                        <td>
                            <div style="width:300px; background-color:#ccc"><img src="$QuizBar" width="$quizaveragewidth" height="10" alt="$quizpercent %" /></div>
                        </td>
                    </tr>
                </table>
            </td>
        </tr><tr>
            <td class="catbg">$imgquizhome</td>
        </tr>
    </table>
    </div>
    <div style="margin-bottom: 8px; height: 15em; overflow:auto">
    <table class="pad_4px cs_thin" style="margin-left:0, width:98%">
~;

    fopen( QUIZLOGFILE, "$memberdir/$username.quizlog" );
    @quizlog = <QUIZLOGFILE>;
    fclose(QUIZLOGFILE);

    for my $i (@quizlog) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    chomp $quizlog;
    $logcount = @quizlog;

    for my $i ( 0 .. ( $logcount - 1 ) ) {
        my (
            $log_quizname,    $log_question, $log_answertxt,
            $log_solutiontxt, $log_commenttxt
        ) = split /[|]/xsm, $quizlog[$i];
        if ( $quizname eq $log_quizname ) {
            if ( $log_answertxt eq $log_solutiontxt ) {
                $log_wrongcorrect = $quiztxt{'78'};
            }
            else { $log_wrongcorrect = $quiztxt{'79'} }

            # no html code in answers and questions
            $log_question = clean1($log_question);
            $log_answertxt = clean1($log_answertxt);
            $log_solutiontxt = clean1($log_solutiontxt);
            $log_commenttxt = clean1($log_commenttxt);

            # censor quiz answers and questions
            LoadCensorList();
            foreach (@censored) {
                my ( $tmpa, $tmpb ) = @{$_};
                $log_question =~ s/\Q$tmpa\E/$tmpb/gism;
                $log_answertxt =~ s/\Q$tmpa\E/$tmpb/gism;
                $log_solutiontxt =~ s/\Q$tmpa\E/$tmpb/gism;
                $log_commenttxt =~ s/\Q$tmpa\E/$tmpb/gism;
            }

            # do YaBBC  on the quiz answers and questions
            $message = $log_question;
            if ($enable_ubbc) {
                enable_yabbc();
            }
            $log_question = $message;

            $message = $log_answertxt;
            if ($enable_ubbc) { DoUBBC(); }
            $log_answertxt = $message;

            $message = $log_solutiontxt;
            if ($enable_ubbc) { DoUBBC(); }
            $log_solutiontxt = $message;

            $message = $log_commenttxt;
            if ($enable_ubbc) { DoUBBC(); }
            $log_commenttxt = $message;

            $yymain .= qq~<tr>
        <td colspan="2" class="catbg">
            $log_question
        </td>
    </tr><tr>
        <td class="windowbg2" style="width:23%">
            $quiztxt{'75'}
        </td>
        <td class="windowbg2">
            $log_answertxt
        </td>
    </tr><tr>
        <td class="windowbg2">
            $quiztxt{'76'}
        </td>
        <td class="windowbg2">
            $log_solutiontxt
        </td>
    </tr><tr>
        <td colspan="2" class="windowbg2">
            $quiztxt{'77'} $log_wrongcorrect
            $log_commenttxt
        </td>
    </tr>~;
        }
    }

    $yymain .= q~
    </table>
    </div>
~;

    # Load Quiz Highscore
    fopen( FILE, "$vardir/$quizname.quizresult" );
    @quizscorelist = <FILE>;
    fclose(FILE);

    chomp @quizscorelist;
    $quizscores = @quizscorelist;
    $i          = 0;
    $x          = 0;

    while ( $i < $quizscores ) {
        my ( $tmp_username, $tmp_score, $tmp_date ) = split /[|]/xsm,
          $quizscorelist[$i];
        chomp $tmp_date;
        if ( !$tmp_date ) { $i++; next; }
        if ( $tmp_date =~
            m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
        {
            $tmp_date = stringtotime($tmp_date);
        }
        $date1 = $tmp_date;
        calcdifference();
        $days_reg = $result;
        $tmpquizscorelist[$x] =
          qq~$tmp_username|$tmp_score|$tmp_date|$days_reg~;
        $x++;
        $i++;
    }

    $quizscores = @tmpquizscorelist;

    # Sort quizscorelist by highscore

    @sortscorelist =
      map { $_->[0] }
      sort { ( $b->[2] ) <=> ( $a->[2] ) || uc( $a->[0] ) cmp uc( $b->[0] ) }
      map { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmpquizscorelist);

    $highscorelength = $QuizHighScoreLength;

    if ( $INFO{'sort'} eq 'high' )        { $highscorelength = $quizscores; }
    if ( $highscorelength > $quizscores ) { $highscorelength = $quizscores; }
    if ( $INFO{'sort'} eq 'latest' )      { $highscorelength = 0; }

    if ( $highscorelength > 0 ) {
        $yymain .= qq~
    <div style="float: left; width: 100%; margin-bottom: 8px;">
        <div style="float: left; width: 49%;">
        <table class="pad_4px cs_thin">
        <tr>
            <td colspan="3" class="titlebg center">
                $quiztxt{'19'}
            </td>
        </tr><tr>
            <td class="catbg">
                $quiztxt{'14'}
            </td>
            <td class="catbg">
                $quiztxt{'15'}
            </td>
            <td class="catbg">
                $quiztxt{'16'}
            </td>
        </tr>~;
    }

    for my $i ( 0 .. ( $highscorelength - 1 ) ) {
        my ( $tmp_username, $highscore, $tmp_date, $days_reg ) = split /[|]/xsm,
          $sortscorelist[$i];
        $tmp_date = timeformat($tmp_date);

        LoadUser($tmp_username);
        if ( ${ $uid . $tmp_username }{'realname'} ) {
            $tmp_userprofile = qq~$link{$tmp_username}~;
        }
        else {
            $tmp_userprofile = "$tmp_username";
        }
        $yymain .= qq~<tr>
            <td class="windowbg2">
                $tmp_userprofile
            </td>
            <td class="windowbg2">
                $highscore
            </td>
            <td class="windowbg2">
                $tmp_date
            </td>
        </tr>~;
    }

    if ( $highscorelength < $quizscores && $highscorelength > 0 ) {
        $yymain .= qq~<tr>
            <td colspan="3" class="catbg">
                <a href="$scripturl?action=quizdisplay;name=$quizname;sort=high">$quiztxt{'17'}</a>
            </td>
        </tr>~;
    }

    $yymain .= q~
        </table>
        </div>
~;

    # Sort quizscorelist by date

    @sortscorelist =
      map { $_->[0] }
      sort { ( $a->[4] ) <=> ( $b->[4] ) || uc( $a->[0] ) cmp uc( $b->[0] ) }
      map { [ $_, ( split /[|]/xsm )[ 0 .. 4 ] ] } (@tmpquizscorelist);

    $highscorelength = $QuizHighScoreLength;
    if ( $INFO{'sort'} eq 'latest' )      { $highscorelength = $quizscores; }
    if ( $highscorelength > $quizscores ) { $highscorelength = $quizscores; }
    if ( $INFO{'sort'} eq 'high' )        { $highscorelength = 0; }

    if ( $highscorelength > 0 ) {
        $yymain .= qq~
        <div style="float: right; width: 49%;">
        <table class="pad_4px cs_thin">
        <tr>
            <td colspan="3" class="titlebg center">
                $quiztxt{'20'}
            </td>
        </tr><tr>
            <td class="catbg">
                $quiztxt{'14'}
            </td>
            <td class="catbg">
                $quiztxt{'15'}
            </td>
            <td class="catbg">
                $quiztxt{'16'}
            </td>
        </tr>~;
    }

    for my $i ( 0 .. ( $highscorelength - 1 ) ) {
        my ( $tmp_username, $highscore, $tmpdate, $reg_days ) = split /[|]/xsm,
          $sortscorelist[$i];
        $tmpdate = timeformat($tmpdate);

        LoadUser($tmp_username);
        if ( ${ $uid . $tmp_username }{'realname'} ) {
            $tmp_userprofile = qq~$link{$tmp_username}~;
        }
        else {
            $tmp_userprofile = "$tmp_username";
        }

        $yymain .= qq~<tr>
            <td class="windowbg2">
                $tmp_userprofile
            </td>
            <td class="windowbg2">
                $highscore
            </td>
            <td class="windowbg2">
                $tmpdate
            </td>
        </tr>~;
    }

    if ( $highscorelength < $quizscores && $highscorelength > 0 ) {
        $yymain .= qq~<tr>
            <td colspan="3" class="catbg">
                <a href="$scripturl?action=quizresult;name=$quizname;sort=latest">$quiztxt{'17'}</a>
            </td>
        </tr>~;
    }

    $yymain .= q~
        </table>
        </div>
        </div>
~;

    template();
    exit;
}

sub quizquestionmodify {

    if ($iamguest) {
        fatal_error( $error_txt{'no_access'} );
    }

    require "$vardir/quiz2.txt";

    $quizname = $INFO{'name'};
    $date2    = $date;

    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    $quizcreatorname = $quiz[2];

    $access = quizaccesscheck('mod');

    if ($ispublic) {
        fatal_error('quiz_noaddquestion');
    }

    $quizcount = @quiz;

    if ( !$access ) {
        fatal_error('quiz_nomodify');
    }

    $yytitle .= qq~ $quiztxt{'27'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quiz[0]</a> &rsaquo;
    $quiztxt{'27'} ~;

    $quiz[4] = clean1($quiz[4]);

    $yymain .= qq~
    <form action="$scripturl?action=quizmodify2;name=$quizname" method="post">
    <div class="bordercolor" style="margin-bottom: 8px;">
    <table class="pad_4px cs_thin">
    <tr>
        <td class="titlebg center" colspan="2">$quiz[0]</td>
    </tr><tr>
        <td class="catbg" colspan="2">
            $quiztxt{'27'}
        </td>
    </tr><tr>
        <td class="windowbg2 vtop" style="width:23%">
            <b>$quiztxt{'18'}</b>
        </td>
        <td class="windowbg2">
            <textarea cols="70" rows="8" name="message">$quiz[4]</textarea>
            <input type="hidden" name="num" value="4" />
            <input type="hidden" name="answer1" value="" />
            <input type="hidden" name="answer2" value="" />
            <input type="hidden" name="answer3" value="" />
            <input type="hidden" name="answer4" value="" />
            <input type="hidden" name="answer5" value="" />
            <input type="hidden" name="solution" value="" />
            <input type="hidden" name="comment" value="" />
        </td>
    </tr><tr>
        <td class="catbg center" colspan="2">
            <input type="submit" class="button" value="$post_txt{'10'}" />
        </td>
    </tr>
    </table>
    </div>
    </form>
~;
    for my $i ( 9 .. ( $quizcount - 1 ) ) {
        my (
            $question, $solution, $answer1,
            $answer2,  $answer3,  $answer4,
            $answer5,  $comment,  $QuestionTimelimit
        ) = split /[|]/xsm, $quiz[$i];

        $quest_num = $i - 8;
        $solution1 = q{};
        $solution2 = q{};
        $solution3 = q{};
        $solution4 = q{};
        $solution5 = q{};

        if    ( $solution == 1 ) { $solution1 = q~checked="checked"~; }
        elsif ( $solution == 2 ) { $solution2 = q~checked="checked"~; }
        elsif ( $solution == 3 ) { $solution3 = q~checked="checked"~; }
        elsif ( $solution == 4 ) { $solution4 = q~checked="checked"~; }
        else                     { $solution5 = q~checked="checked"~; }

        $question = clean1($question);
        $answer1 = clean1($answer1);
        $answer2 = clean1($answer2);
        $answer3 = clean1($answer3);
        $answer4 = clean1($answer4);
        $answer5 = clean1($answer5);
        $comment = clean1($comment);

        $yymain .= qq~
        <div class="bordercolor" style="float: left; width: 100%; margin-bottom: 8px; padding: 1px;">
        <form action="$scripturl?action=quizmodify2;name=$quizname" method="post">
        <input type="hidden" name="num" value="$i" />
        <table class="pad_4px">
        <tr>
            <td class="windowbg2 vtop" style="width:23%">
                <b>$quiztxt{'39'} $quest_num</b>
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="6" name="message">$question</textarea>
            </td>
        </tr><tr>
            <td class="windowbg2 vtop" colspan="2">
                <b>$quiztxt{'91'}</b><br />
                <span class="small">$quiztxt{'38'}</span>
            </td>
        </tr><tr>
            <td class="windowbg2 top">
                <b>$quiztxt{'40'}</b> <input type="radio" name="solution" value="1" $solution1 class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer1">$answer1</textarea>
            </td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'41'}</b> <input type="radio" name="solution" value="2" $solution2 class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer2">$answer2</textarea>
            </td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'42'}</b> <input type="radio" name="solution" value="3" $solution3 class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer3">$answer3</textarea>
            </td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'43'}</b> <input type="radio" name="solution" value="4" $solution4 class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer4">$answer4</textarea>
            </td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'44'}</b> <input type="radio" name="solution" value="5" $solution5 class="windowbg2" style="border: 0;" />
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="2" name="answer5">$answer5</textarea>
            </td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'92'}</b><br />
                <span class="small">
                    $quiztxt{'93'}
                    $quiztxt{'94'}
                </span>
            </td>
            <td class="windowbg2">
                <textarea cols="70" rows="4" name="comment" tabindex="7">$comment</textarea><br /><br />
~;
        if ( !$QuestionTimelimit ) { $QuestionTimelimit = 0; }
        if ($QuizSetTimelimit) {
            $yymain .= qq~            </td>
        </tr><tr>
            <td class="windowbg2 vtop">
                <b>$quiztxt{'105'}</b><br />
                <span class="small">$quiztxt{'106'} $QuizMaxTimelimit $quiztxt{'107'}</span>
            </td>
            <td class="windowbg2">
                <input type="text" name="QuestionTimelimit" size="4" value="$QuestionTimelimit" />
            </td>
        </tr>~;

        }
        else {
            $yymain .= q~
            <input type="hidden" name="QuestionTimelimit" value="0" />
            </td>
        </tr>~;
        }
        $yymain .= qq~<tr>
            <td class="catbg center" colspan="2">
                <input type="submit" class="button" value="$post_txt{'10'}" />
            </td>
        </tr>
        </table>
        </form>
        </div>
~;
    }

    template();
    exit;
}

sub quizquestionmodify2 {

    require "$vardir/quiz2.txt";
    $quizname = $INFO{'name'};
    $date2    = $date;

    fopen( QUIZFILE, "$vardir/$quizname.quiz" );
    @quiz = <QUIZFILE>;
    fclose(QUIZFILE);

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    chomp @quiz;
    $quizcount = @quiz;
    $num       = $FORM{'num'};

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    $quizcreatorname = $quiz[2];

    $access = quizaccesscheck('mod');

    if ($ispublic) {
        fatal_error('quiz_noaddquestion');
    }

    if ($iamguest) {
        fatal_error( $error_txt{'no_access'} );
    }

    if ( !$access ) {
        fatal_error('quiz_nomodify');
    }

    if ( $num == 4 ) {
        $quiz[4] = $FORM{'message'};
        $quiz[4] = clean1($quiz[4]);
    }
    else {
        $question  = $FORM{'message'};
        $answer1   = $FORM{'answer1'};
        $answer2   = $FORM{'answer2'};
        $answer3   = $FORM{'answer3'};
        $answer4   = $FORM{'answer4'};
        $answer5   = $FORM{'answer5'};
        $solution  = $FORM{'solution'};
        $comment   = $FORM{'comment'};
        $timelimit = $FORM{'QuestionTimelimit'};

        $question = clean1($question);
        $answer1  = clean1($answer1);
        $answer2  = clean1($answer2);
        $answer3  = clean1($answer3);
        $answer4  = clean1($answer4);
        $answer5  = clean1($answer5);
        $comment  = clean1($comment);

        if ( length($question) == 0 ) { fatal_error('quiz_noquestion'); }
        if ( length($answer1) == 0 && $solution == 1 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer2) == 0 && $solution == 2 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer3) == 0 && $solution == 3 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer4) == 0 && $solution == 4 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer5) == 0 && $solution == 5 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( $timelimit =~ /\D/sm ) { fatal_error('quiz_timelimitnumb'); }
        if ( $timelimit > $QuizMaxTimelimit ) {
            $timelimit = $QuizMaxTimelimit;
        }
        $quiz[$num] =
"$question|$solution|$answer1|$answer2|$answer3|$answer4|$answer5|$comment|$timelimit";
    }

    fopen( FILE, ">$vardir/$quizname.quiz" );
    for my $i ( 0 .. ( $quizcount - 1 ) ) {
        print {FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
    }
    fclose(FILE);

    WriteLog();
    $yySetLocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
    redirectexit();
    return;
}

sub quizaccesscheck {
    if ($iamguest) { return 0; }

    require "$vardir/quiz2.txt";

    my $whatcheck = $_[0];

    if ( $whatcheck eq 'add' ) {
        $quizaccess = $QuizAddGroups;
    }
    elsif ( $whatcheck eq 'mod' ) {
        if ( $username ne $quizcreatorname && !$iamadmin ) { return 0; }
        $quizaccess = $QuizModGroups;
    }
    elsif ( $whatcheck eq 'del' ) {
        if ( $username ne $quizcreatorname && !$iamadmin ) { return 0; }
        $quizaccess = $QuizDelGroups;
    }

    if ( $iamadmin || $quizaccess eq q{} ) { return 1; }

    my $access = 0;
    $quizaccess =~ s/\, /\,/gsm;
    @allow_groups = split /\,/xsm, $quizaccess;
    if ( !exists $memberunfo{$username} ) { LoadUser($username); }
    $memberinform = $memberunfo{$username};
    for my $element (@allow_groups) {
        chomp $element;
        if ( $element eq $memberinform ) { $access = 1; }
        $memberaddgroup{$username} =~ s/\, /\,/gsm;
        for my $memberaddgroups ( split /\,/xsm, $memberaddgroup{$username} ) {
            chomp $memberaddgroups;
            if ( $element eq $memberaddgroups ) { $access = 1; last; }
        }
    }
    return $access;
}

sub drawEditor {
    $maxchars   = $_[0];
    $MaxMessLen = $maxchars;
    require Sources::ContextHelp;
    require Sources::Postbox;
    ContextScript('post');
    $editmain .= $ctmain;
    if ( $enable_ubbc && $showyabbcbutt ) {
        $my_ubbc_yes .= qq~<b>$post_txt{'252'}:</b><br />
            <div class="style_ubbc_box">~;
        $my_ubbc_yes .= postbox();
        $my_ubbc_yes .= q~</div>~;
    }
    $editmain .= $my_ubbc_yes;
    $editmain .= postbox2();
    $editmain .= postbox3();

    # SpellChecker start
    if ($enable_spell_check) {
        $yyinlinestyle .= googiea();
        $userdefaultlang = ( split /-/xsm, $abbr_lang )[0];
        $userdefaultlang ||= 'en';
        $editmain .= googie($userdefaultlang);
    }

    # SpellChecker end

    $editmain .= qq~
<script type="text/javascript">
var noalert = true, gralert = false, rdalert = false, clalert = false;
var cntsec = 0;

function tick() {
  cntsec++;
  calcCharLeft();
  var timerID = setTimeout("tick()",1000);
}

function calcCharLeft() {
  var clipped = false;
  var maxLength = $maxchars;
  if (document.postmodify.message.value.length > maxLength) {
    document.postmodify.message.value = document.postmodify.message.value.substring(0,maxLength);
    var charleft = 0;
    clipped = true;
  } else {
    charleft = maxLength - document.postmodify.message.value.length;
  }
  document.postmodify.msgCL.value = charleft
  if (charleft >= 100 && noalert) { noalert = false; gralert = true; rdalert = true; clalert = true; document.images.chrwarn.src="$defaultimagesdir/green1.gif"; }
  if (charleft < 100 && charleft >= 50 && gralert) { noalert = true; gralert = false; rdalert = true; clalert = true; document.images.chrwarn.src="$defaultimagesdir/green0.gif"; }
  if (charleft < 50 && charleft > 0 && rdalert) { noalert = true; gralert = true; rdalert = false; clalert = true; document.images.chrwarn.src="$defaultimagesdir/red0.gif" }
  if (charleft == 0 && clalert) { noalert = true; gralert = true; rdalert = true; clalert = false; document.images.chrwarn.src="$defaultimagesdir/red1.gif"; }
  return clipped;
}
tick();
</script>~;

    return $editmain;
}

sub clean1 {
    my ($tmp) = @_;
    $tmp =~ s/<br>/\n/gsm;
    $tmp =~ s/<br \/>/\n/gsm;
    $tmp =~ s/</&lt;/gsm;
    $tmp =~ s/>/&gt;/gsm;
    $tmp =~ s/\n/<br \/>/gsm;
    return $tmp;
}
1;
